﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

//حل سودوکو به وسیله جستجوی آگاهانه 
//A*

namespace SudokuSolve
{
    public class Sudoku
    {
        //N*N  Board
        int N = 3;

        //Main Board
        int[,] board = new int[9, 9];

        //this arry used by methods that Checked the value is unique in row and col and inner cubes
        bool[] checkValue = new bool[10];

        //constructore
        public Sudoku()
        {
            //Fill main Array board by 0 value
            for (int i = 0; i <= (N * N)-1; i++)
            {
                for (int j = 0; j <= (N * N)-1; j++)
                {
                    board[i, j] = 0;
                }
            }

            //fill check array with default value
            for (int i = 0; i <= 9; i++)
            {
                checkValue[i] = true;
            }
        }

        // set value in main board
        //i , j position of Drayh array
        //value i,j drayh array
        public void setSquare(int i, int j, int value)
        {
            board[i, j] = value;
        }

        //get value for acrross row and col value
        // i = row
        // j = col
        public int getSquare(int i, int j)
        {
            return board[i, j];
        }


        //this method Add "|" and "-" and "+" to show result in output.%3 put "|" in each ternary in row.
        //
        public string Show()
        {
            string Temp = string.Empty;

            for (int i = 0; i <= (N * N)-1; i++)
            {
                for (int j = 0; j <= (N * N)-1; j++)
                {
                    //this if dont allow to loop for input "|" at first
                   if (j % 3 == 0 && j != 0)
                    {
                        Temp += "  |  ";
                    }
                    else
                    {
                        //this if check for put "+" in out put at Confluence row and col in each cubes number
                        if (i % 3 == 0 && i != 0 && j == 0)
                        {
                            for (int k = 0; k < 18; k++)
                            {
                                if (k % 6 == 0 && k != 0)
                                {
                                    Temp += "-------";
                                }
                                else
                                {
                                    Temp += "---";
                                }
                            }
                            Temp += "\r\n";
                        }
                    }
                   // insert dot Instead of zero
                    if (board[i, j] == 0)
                    {
                        Temp += "  .  ";
                    }
                    else
                    {
                        Temp += "  " + board[i, j] + "  ";
                    }
                }
                Temp += "\r\n";
            }
            return Temp;
        }

        //convert boart to string array
        public string[] boardconverttostrarray()
        {
            string[] Temp = new string[81];

            int k = 0;
            for (int i = 0; i <= (N * N)-1 ; i++)
            {
                for (int j = 0; j <= (N * N)-1 ; j++)
                {
                    Temp[k] = Convert.ToString(getSquare(i, j));
                    k++;
                }
            }
            return Temp;
        }

        //convert string to string Array
        // board text string recive and temp return array
        public string[] strrinconverttostrarray(string boardtext)
        {
            string[] Temp = new string[1000];


            for (int i = 0; i < boardtext.Length; i++)
            {
                Temp[i] = Convert.ToString(boardtext[i]);
            }
            return Temp;
        }

        //fill main board by input string array
        public void Fill(string[] lines)
        {
            int k = 0;
            for (int i = 0; i <= (N * N)-1; i++)
            {
                for (int j = 0; j <= (N * N)-1; j++)
                {
                    board[i, j] = int.Parse(lines[k]);
                    k++;
                }
            }
        }

        //fill board by input string array and delete any + - | in input string
        // this method for check two condition use peterson solution
        public void FancyFill(string[] lines)
        {
            for (int i = 0; i <= (N * N)-1; i++)
            {
                for (int j = 0; j <= (N * N)-1; j++)
                {
                    board[i, j] = 0;
                }
            }

            int k = 0;

            bool flag = true;

            for (int i = 0; i <= (N * N)-1; i++)
            {
                for (int j = 0; j <= (N * N)-1; j++)
                {
                    flag = true;
                    //peterson solution
                    for (int l = k; l < lines.Length && flag; l++)
                    {

                        if (char.IsDigit(char.Parse(lines[l])))
                        {
                            board[i, j] = int.Parse(lines[l]);
                            flag = false;
                        }
                        if (char.Parse(lines[l]) == '.')
                        {
                            board[i, j] = 0;
                            flag = false;
                        }

                        k++;
                    }
                }

            }
        }

        // check sudoku is solved? if true return true
        public bool isSolution()
        {
            if (isComplete() && isRowCheckUnique() && isColCheckUnique() && isCubeUnique())
            {
                return true;
            }
            return false;
        }

        //check board array is complete by number?
        public bool isComplete()
        {
            for (int i = 0; i <= (N * N)-1; i++)
            {
                for (int j = 0; j <= (N * N)-1; j++)
                {
                    if (!(board[i, j] <= 9 && board[i, j] >= 1))
                    {
                        return false;
                    }
                }
            }


            return true;
        }

        //values in rows is unique? use check value array for true or false
        public bool isRowCheckUnique()
        {
            for (int i = 0; i <= (N * N)-1; i++)
            {
                for (int j = 0; j <= (N * N)-1; j++)
                {
                    //checkValue[0] = true;

                    if (checkValue[board[i,j]] == true)
                    {
                        checkValue[board[i,j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
                for (int k = 0; k <= 9; k++)
                {
                   checkValue[k] = true;
               }
            }


            return true;
        }

        //this method check one row with j column
        //if row unique return true.
        public bool isOneRowCheckUniqe(int j)
        {
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }

            for (int i = 0; i <= (N * N) - 1; i++)
            {
               checkValue[0] = true;

                if (checkValue[board[j,i]] == true)
                {
                    checkValue[board[j,i]] = false;
                }
                else
                {
                    return false;
                }
            }

            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }
            return true; 
        }

        //values in columns is unique? use check value array for true or false
        public bool isColCheckUnique()
        {
            for (int i = 0; i <= (N * N)-1; i++)
            {
                for (int j = 0; j <= (N * N)-1; j++)
                {
                    if (checkValue[board[i,j]] == true)
                    {
                        checkValue[board[i,j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
                for (int k = 0; k <= 9; k++)
                {
                    checkValue[k] = true;
                }
            }
  
            return true;
        }

        //this method check one columns with j column
        //if row unique return true.
        public bool isOneColCheckUniqe(int i)
        {
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }

            for (int j = 0; j <= (N * N) - 1; j++)
            {
                checkValue[0] = true;

                if (checkValue[board[j,i]] == true)
                {
                    checkValue[board[j,i]] = false;
                }
                else
                {
                    return false;
                }
            }

            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }
            return true;
        }

        //this method check evry 3*3 is 1..9 value?
        //if is unique return true.
        public bool isCubeUnique()
        {

            #region iscubeunique
            //1,1
            for (int i = 0; i <= 2; i++)
            {
                for (int j = 0; j <= 2; j++)
                {
                    checkValue[0] = true;

                    if (checkValue[board[i, j]] == true)
                    {
                        checkValue[board[i, j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
               

            }
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }
            //1,2
            for (int i = 0; i <= 2; i++)
            {
                for (int j = 3; j <= 5; j++)
                {
                    checkValue[0] = true;

                    if (checkValue[board[i, j]] == true)
                    {
                        checkValue[board[i, j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
               
            }
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }

            //1,3
            for (int i = 0; i <= 2; i++)
            {
                for (int j = 6; j <= 8; j++)
                {
                    checkValue[0] = true;

                    if (checkValue[board[i, j]] == true)
                    {
                        checkValue[board[i, j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
                
            }
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }
            //2,1
            for (int i = 3; i <= 5; i++)
            {
                for (int j = 0; j <= 2; j++)
                {
                    checkValue[0] = true;

                    if (checkValue[board[i, j]] == true)
                    {
                        checkValue[board[i, j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
                
            }
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }
            //2,2
            for (int i = 3; i <= 5; i++)
            {
                for (int j = 3; j <= 5; j++)
                {
                    checkValue[0] = true;

                    if (checkValue[board[i, j]] == true)
                    {
                        checkValue[board[i, j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
               
            }
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }
            //2,3
            for (int i = 3; i <= 5; i++)
            {
                for (int j = 6; j <= 8; j++)
                {
                    checkValue[0] = true;

                    if (checkValue[board[i, j]] == true)
                    {
                        checkValue[board[i, j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
               
            }
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }
            //3,1
            for (int i = 6; i <= 8; i++)
            {
                for (int j = 0; j <= 2; j++)
                {
                    checkValue[0] = true;

                    if (checkValue[board[i, j]] == true)
                    {
                        checkValue[board[i, j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
               
            }
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }
            //3,2
            for (int i = 6; i <= 8; i++)
            {
                for (int j = 3; j <= 5; j++)
                {
                    checkValue[0] = true;

                    if (checkValue[board[i, j]] == true)
                    {
                        checkValue[board[i, j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
               
            }
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }
            //3,3,
            for (int i = 6; i <= 8; i++)
            {
                for (int j = 6; j <= 8; j++)
                {
                    checkValue[0] = true;

                    if (checkValue[board[i, j]] == true)
                    {
                        checkValue[board[i, j]] = false;
                    }
                    else
                    {
                        return false;
                    }
                }
               
            }
            for (int k = 0; k <= 9; k++)
            {
                checkValue[k] = true;
            }

            return true;
            #endregion
        }

        
       
        //candidate value global list
        int[, ,] InnerCandidateValue = new int[10, 10, 11];

        //inner candidate value fill 
        public void FillcandidateValue()
        {
            //fill candidate value in innner list
            for (int i = 0; i < 10; i++)
            {
                for (int j = 0; j < 10; j++)
                {
                    for (int k = 0; k < 11; k++)
                    {
                        InnerCandidateValue[i, j, k] = k;
                    }
                }
            } 
        }

        //this method solve sudoku by backtracking solution
        public void SolvedSudoku()
        {
            FillcandidateValue();
            //solve
            for (int i = 0; i <= (N * N) - 1; i++)
            {
                for (int j = 0; j <= (N * N) - 1; j++)
                {
                    if (board[i , j] == 0)
                    {
                        for (int l = 0; l <= 8; l++)
                        {
                            board[i, j] = InnerCandidateValue[i, j, l+1];

                            if ((isOneRowCheckUniqe(i) && isOneColCheckUniqe(j) && isCubeUnique()))
                            {
                                l = 10;
                            }
                        }
                    }
                }
            }
        }
    }
}

     